> For the complete documentation index, see [llms.txt](https://docs.rierino.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.rierino.com/design/user-interface/uis/extended-scope/extra-events.md).

# Extra Events

Various actions such as "On Change", "On Blur" for widgets and "On Save" for item editors can use extra event configurations to trigger custom logic after these actions are performed. Extra event configurations have the following settings:

* **Action:** Type of action to trigger after
* **Prevent Default:** Whether the original action should be performed or ignored (e.g. if true, On Change does not perform the actual data change)
* **Code:** JavaScript code to execute when triggered

The custom code has access to a "props" variable, which includes:

* **data:** Current data in the widget
* **ui:** UI configuration of the widget
* **editorEvents:** Events allowed by the item editor (e.g. onNew, onChange)
* **sendMessage:** Function to trigger snack displays
* **defaultFn:** Original action, which is typically useful if preventDefault is set to true and the original function needs to be triggered after a special logic

Additional values are also available based on the action type (e.g. changes for On Save, event, updated for On Blur, previous, updated for On Change). &#x20;


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.rierino.com/design/user-interface/uis/extended-scope/extra-events.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
